#include <string.h>
#include <stdio.h>
#include <ilwd/ldascontainer.hh>
#include <ilwd/ldasarray.hh>
#include <ilwd/ldasstring.hh>
#include<ilwd/util.hh>
using ILwd::LdasContainer;
using ILwd::LdasArray;
using ILwd::LdasString;
using namespace std;
typedef double BLOB_TYPE;
extern void get_gpstime( double *, double *);
LdasContainer ilwd3process( "processgroup:process:table" );

namespace local {

	const INT_2U ARRAYSIZE = 10000;
	int thistime = (int)time (0) ;
	int numElements;
	double gps_secs ;
	double gps_nanosecs ;
	INT_2U BLOBSIZE = 64;
	LdasContainer program_cont ( "processgroup:process:program" ); 
	LdasContainer version_cont ( "processgroup:process:version" ); 
	LdasContainer cvs_repository_cont ( "processgroup:process:cvs_repository" ); 
	INT_4S	cvs_entry_time[ARRAYSIZE];
	LdasContainer comment_cont ( "processgroup:process:comment" ); 
	LdasContainer node_cont ( "processgroup:process:node" ); 
	LdasContainer username_cont ( "processgroup:process:username" ); 
	INT_4S	unix_procid[ARRAYSIZE];
	INT_4S	start_time[ARRAYSIZE];
	INT_4S	end_time[ARRAYSIZE];
	INT_4S	param_set[ARRAYSIZE];
	LdasContainer ifos_cont ( "processgroup:process:ifos" ); 
} // end namespace

using namespace local;

static void setup_program () {

// fill in program array
// primary key
// NOT NULL
	CHAR program[16];
	CHAR programattr[216];

	for (int i=0; i < numElements; i++) {
		snprintf(program, (size_t) 16, "program_%d", i + thistime + 1 );
		sprintf(programattr, "process:%s", program);
		LdasArray< CHAR > program_vector ( program, strlen(program),
			"processgroup:process:program" );
		program_vector.setComment( programattr );
		program_cont.push_back( program_vector );
	}
}

static void setup_version () {

// fill in version array
	CHAR version[64];
	CHAR versionattr[264];

	for (int i=0; i < numElements; i++) {
		snprintf(version, (size_t) 64, "version_%d", i + thistime + 1 );
		sprintf(versionattr, "process:%s", version);
		LdasArray< CHAR > version_vector ( version, strlen(version),
			"processgroup:process:version" );
		version_vector.setComment( versionattr );
		version_cont.push_back( version_vector );
	}
}

static void setup_cvs_repository () {

// fill in cvs_repository array
	CHAR cvs_repository[256];
	CHAR cvs_repositoryattr[456];

	for (int i=0; i < numElements; i++) {
		snprintf(cvs_repository, (size_t) 256, "cvs_repository_%d", i + thistime + 1 );
		sprintf(cvs_repositoryattr, "process:%s", cvs_repository);
		LdasArray< CHAR > cvs_repository_vector ( cvs_repository, strlen(cvs_repository),
			"processgroup:process:cvs_repository" );
		cvs_repository_vector.setComment( cvs_repositoryattr );
		cvs_repository_cont.push_back( cvs_repository_vector );
	}
}

static void setup_cvs_entry_time () {

// fill in cvs_entry_time array
	for (int i=0; i < numElements; i++) {
		cvs_entry_time[i] = (INT_4S) i + thistime + 1 ;
	}
}

static void setup_comment () {

// fill in comment array
	CHAR comment[240];
	CHAR commentattr[440];

	for (int i=0; i < numElements; i++) {
		snprintf(comment, (size_t) 240, "comment_%d", i + thistime + 1 );
		sprintf(commentattr, "process:%s", comment);
		LdasArray< CHAR > comment_vector ( comment, strlen(comment),
			"processgroup:process:comment" );
		comment_vector.setComment( commentattr );
		comment_cont.push_back( comment_vector );
	}
}

static void setup_node () {

// fill in node array
// primary key
// NOT NULL
	CHAR node[64];
	CHAR nodeattr[264];

	for (int i=0; i < numElements; i++) {
		snprintf(node, (size_t) 64, "node_%d", i + thistime + 1 );
		sprintf(nodeattr, "process:%s", node);
		LdasArray< CHAR > node_vector ( node, strlen(node),
			"processgroup:process:node" );
		node_vector.setComment( nodeattr );
		node_cont.push_back( node_vector );
	}
}

static void setup_username () {

// fill in username array
// NOT NULL
	CHAR username[16];
	CHAR usernameattr[216];

	for (int i=0; i < numElements; i++) {
		snprintf(username, (size_t) 16, "username_%d", i + thistime + 1 );
		sprintf(usernameattr, "process:%s", username);
		LdasArray< CHAR > username_vector ( username, strlen(username),
			"processgroup:process:username" );
		username_vector.setComment( usernameattr );
		username_cont.push_back( username_vector );
	}
}

static void setup_unix_procid () {

// fill in unix_procid array
// primary key
// NOT NULL
	for (int i=0; i < numElements; i++) {
		unix_procid[i] = (INT_4S) i + thistime + 1 ;
	}
}

static void setup_start_time () {

// fill in start_time array
// primary key
// NOT NULL
	get_gpstime( &gps_secs, &gps_nanosecs );
	for (int i=0; i < numElements; i++) {
		start_time[i] = (INT_4S) ( i + gps_secs );}
}

static void setup_end_time () {

// fill in end_time array
	get_gpstime( &gps_secs, &gps_nanosecs );
	for (int i=0; i < numElements; i++) {
		end_time[i] = (INT_4S) ( i + gps_secs );
}
}

static void setup_process_id () {

// fill in process_id array
// NOT NULL
// process_id is uniqueId, generated by metadataAPI

}

static void setup_param_set () {

// fill in param_set array
	for (int i=0; i < numElements; i++) {
		param_set[i] = (INT_4S) i + thistime + 1 ;
	}
}

static void setup_ifos () {

// fill in ifos array
	CHAR ifos[12];
	CHAR ifosattr[212];

	for (int i=0; i < numElements; i++) {
		snprintf(ifos, (size_t) 12, "ifos_%d", i + thistime + 1 );
		sprintf(ifosattr, "process:%s", ifos);
		LdasArray< CHAR > ifos_vector ( ifos, strlen(ifos),
			"processgroup:process:ifos" );
		ifos_vector.setComment( ifosattr );
		ifos_cont.push_back( ifos_vector );
	}
}

void setup_process ( int dims ) 
{
	numElements = dims ;
	if	( dims == 1000 ) {
		BLOBSIZE = 5 ;
	}
	setup_program();
	ilwd3process.push_back(  program_cont ) ;
	setup_version();
	ilwd3process.push_back(  local::version_cont ) ;
	setup_cvs_repository();
	ilwd3process.push_back(  cvs_repository_cont ) ;
	setup_cvs_entry_time();
	ilwd3process.push_back(  LdasArray< INT_4S >(cvs_entry_time, numElements,
	"processgroup:process:cvs_entry_time" ) );
	setup_comment();
	ilwd3process.push_back(  comment_cont ) ;
	setup_node();
	ilwd3process.push_back(  node_cont ) ;
	setup_username();
	ilwd3process.push_back(  username_cont ) ;
	setup_unix_procid();
	ilwd3process.push_back(  LdasArray< INT_4S >(unix_procid, numElements,
	"processgroup:process:unix_procid" ) );
	setup_start_time();
	ilwd3process.push_back(  LdasArray< INT_4S >(start_time, numElements,
	"processgroup:process:start_time" ) );
	setup_end_time();
	ilwd3process.push_back(  LdasArray< INT_4S >(end_time, numElements,
	"processgroup:process:end_time" ) );
	setup_process_id();
	setup_param_set();
	ilwd3process.push_back(  LdasArray< INT_4S >(param_set, numElements,
	"processgroup:process:param_set" ) );
	setup_ifos();
	ilwd3process.push_back(  ifos_cont ) ;
}

#ifdef TESTMAIN 
 void setup_process( int dims ); 

 int main(int argc, char **argv) {
 	LdasContainer ilwd1( "ligo:ldas:file" );
 	setup_process( atoi ( argv [1] ) );
 	ilwd1.push_back( ilwd3process );
 	ILwd::writeHeader(cout);
 	ilwd1.write( 0, 4, cout, ILwd::ASCII, ILwd::NO_COMPRESSION );
 	//ilwd1.write( 0, 4, cout, ILwd::BINARY, ILwd::NO_COMPRESSION );
 	cout << endl;
}
#endif
